      PROGRAM STRETCH
c     INCLUDE 'REMAPP.HDR'
C  LINK WITH DISKIO,PACK,UNPACK,REMLOG,DATE,TIME,EXIT
C
C       THIS PROGRAM DEVELOPED BY DON SAWATZKY AND BOB KLINE
C       WRITTEN BY BOB KLINE
C       STRETCH IS A PROGRAM TO STRETCH DATA IN RANGE (0,255)
C       OR DATA OUT OF RANGE
C       FAST STRETCH DATA IN RANGE : SLOW STRETCH DATA OUT
C       OF RANGE  THE USER MAY DEFINE A WINDOW TO WORK IN
C
C
      INTEGER*4 IN(128),OUT(128)
      INTEGER*2 IBUF(8192)
      CHARACTER*1 INS
      COMMON IBUF,IN,OUT
        DATA JOB/1/
C
C...... OPEN INPUT FILE
C...DOCUMENTATION FOR A JOB
1     CALL REMLOG('    ========STRETCH=======   ')
C
        CALL DISKIO(0,10,IBUF,IN)
       IF(IN(1).LT.0)CALL EXIT(3)
      OUT(1)=8
       OUT(2)=IN(2)
C
C.......OPEN OUTPUT FILE, OUT(1)=BITS/BYTE
C
        CALL DISKIO(0,11,IBUF,OUT)
       IF(OUT(1).LT.0)CALL EXIT(3)
       CALL GETTAB
        WRITE(6,12)
12        FORMAT(//1X,'PROCESS ANOTHER FILE /')
        READ(5,10)INS
10        FORMAT(A1)
        IF((INS.EQ.'N').OR.(INS.EQ.'n')) GO TO 14
        JOB=JOB+1
        WRITE(6,13) JOB
13        FORMAT(//1X,'** BEGIN STRETCH NO.',I3,' **'//)
        GO TO 1
C
C....... END OF EXECUTION
C
14        CONTINUE
      STOP
      END
C  SUBROUTINE GETTAB INPUT MAPPING PAIRS
C
C
           SUBROUTINE GETTAB
      CHARACTER II*50
           INTEGER*4 IN(128),OUT(128)
      INTEGER*2 IBUF(8192)
           INTEGER*2 IARG(256),IRSLT(256)
      COMMON IBUF,IN,OUT
           WRITE(6,20)
20           FORMAT(/1X,'HOW MANY MAPPING PAIRS ?  0=TEXT FILE /')
      READ(5,*) NPAIRS
C
C...... IF NPAIRS EQUAL 0  INPUT FROM STRETCH.DAT
C
            IF(NPAIRS.EQ.0)GO TO 45
           WRITE(6,10)
10           FORMAT(/1X,'INPUT MAPPING PAIRS, ONE PAIR PER LINE. '/)
      DO 42 K=1,NPAIRS
42         READ(5,*)IARG(K),IRSLT(K)
           GO TO 51
45     WRITE(6,451)
451      FORMAT(1X,'NAME OF FILE CONTAINING PAIRS?')
       READ(5,1) II
1     FORMAT(A50)
      OPEN(15,FILE=II,STATUS='OLD',FORM='FORMATTED',
     &IOSTAT=ISTAT)
      IF(ISTAT.NE.0) THEN
      WRITE(6,*)' UNABLE TO OPEN TABLE FILE.  STATUS = ',ISTAT
      CALL EXIT(255)
      ENDIF
       NPAIRS=1
46       READ(15,*,END=461) IARG(NPAIRS),IRSLT(NPAIRS)
      NPAIRS=NPAIRS+1
      GOTO 46
C...DOCUMENTATION FOR A JOB
461   NPAIRS=NPAIRS-1
       WRITE(4,47) II,NPAIRS
47       FORMAT(1X,'PAIRS FROM FILE',A50/
     &'  WITH ',I4,' MAP PAIRS'/)
C
C.......WRITE THE LOG  APPEND TO IMAGE.DAT
C
C...DOCUMENTATION FOR A JOB
51         WRITE(4,90)OUT(8),OUT(9),IN(8),IN(9)
90           FORMAT(/5X,'FILE ',2A4,' CREATED FROM FILE ',2A4)
           WRITE(4,91) NPAIRS
91           FORMAT(/5X,'NUMBER OF MAPPING PAIRS USED ',I5)
           WRITE(4,92)
           WRITE(4,93)(IARG(K),IRSLT(K),K=1,NPAIRS)
92           FORMAT(/25X,'INPUT    MAPS TO    OUTPUT'/)
93           FORMAT(25X,I5,16X,I5)
      IF(IARG(NPAIRS).GT.32767.OR.IRSLT(NPAIRS).GT.255)
     #STOP'LAST ARG OR RESULT TOO LARGE!'
           CALL FAST(IARG,IRSLT,NPAIRS)
           RETURN
           END
C  SUBROUTINE FAST  LOOKUP TABLE IN RANGE (0-255)
C
C
        SUBROUTINE FAST(IARG,IRSLT,NPAIRS )
      INTEGER*4 IN(128),OUT(128)
      INTEGER*2 IBUF(8192)
        INTEGER*2 ITAB(32768),IARG(256),IRSLT(256)
      COMMON IBUF,IN,OUT
        WRITE(6,9)
9        FORMAT(1X,'*** FAST STRETCH BEGINS ***'//)
C
C  ASSIGN VALUES TO LOOKUP TABLE
C  ITAB(I+1) CONTAINS DN VALUE ASSIGNED FOR PREVIOUS DN VALUE I
C
      IF(IARG(1).LT.0) IARG(1)=0
      IF(IARG(1).GT.32767) IARG(1)=32767
      IF(IRSLT(1).LT.0) IRSLT(1)=0
      IF(IRSLT(1).GT.255) IRSLT(1)=255
      DO 10,J=1,IARG(1)+1
10    ITAB(J)=IRSLT(1)
      DO 20,I=2,NPAIRS
         IF(IARG(I).LT.0) IARG(I)=0
         IF(IARG(I).GT.32767) IARG(I)=32767
         IF(IRSLT(I).LT.0) IRSLT(I)=0
         IF(IRSLT(I).GT.255) IRSLT(I)=255
         IF (IARG(I).EQ.IARG(I-1)) GOTO 20
         AM=FLOAT(IRSLT(I)-IRSLT(I-1))/FLOAT(IARG(I)-IARG(I-1))
         DO 30,J=IARG(I-1)+1,IARG(I)
            ITAB(J+1)=IRSLT(I-1)+INT(AM*(J-IARG(I-1))+SIGN(.5,AM))
30       CONTINUE
20    CONTINUE
      IF (IARG(NPAIRS).GT.32767) GOTO 41
      DO 40,J=IARG(NPAIRS),32767
40    ITAB(J+1)=IRSLT(NPAIRS)
41    CONTINUE
C
C...... FAST STRETCH READ LOOP
C
        DO 45 J=1,IN(3)
        CALL DISKIO(9,10,IBUF,IN)
      IF(IN(1).EQ.-1) GOTO 46
      IF(IN(1).LT.-1) CALL EXIT(3)
        IF(IN(25).EQ.8) CALL UNPACK(IBUF,IN)
        DO 48 K=1,IN(2)
      IF(IBUF(K).LT.0) IBUF(K)=0
      IF(IBUF(K).GT.32767) IBUF(K)=32767
48        IBUF(K)=ITAB(IBUF(K)+1)
        CALL PACK(IBUF,OUT)
        CALL DISKIO(10,11,IBUF,OUT)
      IF(OUT(1).LT.0) CALL EXIT(3)
45        CONTINUE
        IN(1)=0
46        CALL DISKIO(6,10,IBUF,IN)
        CALL DISKIO(6,11,IBUF,OUT)
        RETURN
        END
