5 REM Program TMCAL to Calculate TM Reflectance Calibration Factors
10 KEY OFF: CLS
15 CLEAR
20  FOR X = 5 TO 75
30  LOCATE 1, X: PRINT CHR$(220)
40  LOCATE 8, X: PRINT CHR$(220)
50  NEXT X
60   FOR Y = 2 TO 8
70   LOCATE Y, 5: PRINT CHR$(219): LOCATE Y, 75: PRINT CHR$(219)
80   NEXT Y
90 LOCATE 3, 18: PRINT "CALIBRATING LANDSAT TM DATA TO REFLECTANCE"
100 PRINT
110 LOCATE 5, 11: PRINT "ALPHA and BETA values can be used in ARITH to calibrate data"
120 LOCATE 7, 33: COLOR 0, 7: PRINT "Ready Printer?": COLOR 7, 0
140 REM GET LANDSAT TM DATA PARAMETERS
150 LOCATE 11, 10: PRINT "When was TM data processed at Goddard?"
160 LOCATE 13, 20: PRINT "1.  Prior to August 1983 (Scrounge Processing)"
170 LOCATE 14, 20: PRINT "2.  Prior to 15 January 1984 (TIPS)"
180 LOCATE 15, 20: PRINT "3.  After 15 January 1984 (TIPS)"
190 LOCATE 17, 20: INPUT "SELECT APPROPRIATE INTERVAL (1, 2, or 3)"; XINT
200 IF XINT = 1 GOTO 300
210 IF XINT = 2 GOTO 400
220 IF XINT = 3 GOTO 500
225 PRINT
230 PRINT "SELECTED NUMBER IS NOT ONE OF THE CHOICES - TRY AGAIN"
235 INPUT "TYPE ENTER TO RESTART"; G$
240 GOTO 10
300 REM FOR DATA PROCESSED PRIOR TO AUGUST 1983
310   FOR I = 1 TO 7
330   READ RMIN(I), RMAX(I)
340   DATA -.152,15.842,-.284,30.817,-.117,23.463,-.151,22.432,-.037,3.242
350   DATA .2,1.564,-.015,1.7
355   NEXT I
360 GOTO 600
400 REM FOR DATA PROCESSED BETWEEN AUGUST 1983 AND 15 JANUARY 1984
410   FOR I = 1 TO 7
420   RMIN(I) = 0
440   NEXT I
445 RMAX(1) = 14.286: RMAX(2) = 29.125: RMAX(3) = 22.5: RMAX(4) = 21.492: RMAX(5) = 2
446 RMAX(6) = 1.24: RMAX(7) = 1.593
447 RMIN(6) = .484
450 GOTO 600
500 REM FOR DATA PROCESSED AFTER 15 JANUARY 1984
510 RMIN(1) = -.15: RMAX(1) = 15.21: RMIN(2) = -.28: RMAX(2) = 29.68: RMIN(3) = -.12
511 RMAX(3) = 20.43: RMIN(4) = -.15: RMAX(4) = 20.62: RMIN(5) = -.037: RMAX(5) = 2.719
512 RMIN(6) = .1238: RMAX(6) = 1.56: RMIN(7) = -.015: RMAX(7) = 1.438
560 GOTO 600
600 REM GET SATELLITE AND SOLAR ELEVATION INFORMATION
610 LOCATE 19, 20: INPUT "ENTER LANDSAT 4 OR 5 (4 or 5)"; LSAT
620 LOCATE 21, 20: INPUT "ENTER SOLAR ELEVATION ANGLE IN DEGREES"; ANGLE
622 ANGLE=90-ANGLE
625 IF LSAT = 5 GOTO 700
630 ESUN(1) = 195.8: ESUN(2) = 182.8: ESUN(3) = 155.9: ESUN(4) = 104.5: ESUN(5) = 21.91
640 ESUN(6) = 1: ESUN(7) = 7.457
680 GOTO 800
700 ESUN(1) = 195.7: ESUN(2) = 182.9: ESUN(3) = 155.7: ESUN(4) = 104.7: ESUN(5) = 21.93
710 ESUN(6) = 1: ESUN(7) = 7.452
800 REM CALCULATION OF MULTIPLICATIVE AND ADDITIVE FACTORS FOR REFLECTANCE
810   FOR I = 1 TO 7
820   FACTOR1(I) = (RMAX(I) - RMIN(I)) / 255
830   FACTOR2(I) = 3.14159 / (ESUN(I) * COS(ANGLE * (3.14159 / 180)))
850   ALPHA(I) = FACTOR1(I) * FACTOR2(I)
860   BETA(I) = FACTOR2(I) * RMIN(I)
865   NEXT I
900 REM PRINT REFLECTANCE ALPHA AND BETA
905 CLS
910 U$ = "                    #           ####.####          ####.####"
920 PRINT "                         T H E M A T I C   M A P P E R": PRINT
930 PRINT "                             SATELLITE = LANDSAT"; LSAT
940 PRINT "                             SOLAR ELEVATION ="; 90-ANGLE
941 A$ = "ACQUIRED PRIOR TO AUGUST 1983"
942 B$ = "ACQUIRED PRIOR TO 15 JANUARY 1984"
943 C$ = "ACQUIRED AFTER 15 JANUARY 1984"
944 IF XINT = 1 THEN PRINT "                         "; A$
945 IF XINT = 2 THEN PRINT "                       "; B$
946 IF XINT = 3 THEN PRINT "                        "; C$
950 PRINT
955 PRINT "                        REFLECTANCE CALIBRATION FACTORS": PRINT
960 PRINT "                   BAND            ALPHA              BETA"
970 PRINT
980 FOR I = 1 TO 5
990 PRINT USING U$; I, ALPHA(I) * 1000, BETA(I) * 1000
1000 NEXT I
1010 FOR I = 7 TO 7
1020 PRINT USING U$; I, ALPHA(I) * 1000, BETA(I) * 1000
1030 NEXT I
1040 PRINT : PRINT
1050 COLOR 0, 7: PRINT "TYPE: Shift+PrtSc FOR PRINTER OUTPUT": COLOR 7, 0
1060 PRINT
1070 PRINT TAB(30); "ANOTHER RUN? (Y/N)"
1075 INPUT ANS$
1080 IF ANS$ = "Y" OR ANS$ = "y" THEN 10
1090 SYSTEM

